import Foundation
import XCTest

enum FixtureError: Error {
  case fileNotFound(String)
  case dataNotConvertible
}

extension XCTestCase {
  enum Fixtures {}
}

extension XCTestCase.Fixtures {
  static func get(file: String) throws -> String {
    let components = file.split(separator: ".").compactMap { String($0) }
    let base = components.first ?? ""
    let suffix = components.last ?? ""
    guard let path = Bundle.module.path(forResource: base, ofType: suffix) else {
      throw FixtureError.fileNotFound(base + "." + suffix)
    }
    let data = try Data(contentsOf: URL(fileURLWithPath: path))
    guard let string = String(data: data, encoding: .utf8) else {
      throw FixtureError.dataNotConvertible
    }

    return string
  }

  static let sampleSchematicData =
    """
    467..114..
    ...*......
    ..35..633.
    ......#...
    617*......
    .....+.58.
    ..592.....
    ......755.
    ...$.*....
    .664.598..
    """

  static let sampleSchematicDataLine =
    """
    617*......

    """

  static let first05LinesOfSchematicData =
    """
    ............830..743.......59..955.......663..........................................367...........895....899...............826...220......
    .......284.....*............*.....$...+.....*...377..................*.......419.............488...*.......*...................*..-....939..
    ....%.........976..679.461.7..........350..33.........$.380...$...151.897..........295..#......*....105.....418.............481........&....
    ...992.....#......=...../........701................508...*..578........................259...331.................795..945........79........
    .........868........................*.............................17*..........348................441*852........*.....-...........@.....922
    """

  static let challenge =
    """
    ............830..743.......59..955.......663..........................................367...........895....899...............826...220......
    .......284.....*............*.....$...+.....*...377..................*.......419.............488...*.......*...................*..-....939..
    ....%.........976..679.461.7..........350..33.........$.380...$...151.897..........295..#......*....105.....418.............481........&....
    ...992.....#......=...../........701................508...*..578........................259...331.................795..945........79........
    .........868........................*.............................17*..........348................441*852........*.....-...........@.....922
    """

  static let first10LinesOfSchematicData =
    """
    ............830..743.......59..955.......663..........................................367...........895....899...............826...220......
    .......284.....*............*.....$...+.....*...377..................*.......419.............488...*.......*...................*..-....939..
    ....%.........976..679.461.7..........350..33.........$.380...$...151.897..........295..#......*....105.....418.............481........&....
    ...992.....#......=...../........701................508...*..578........................259...331.................795..945........79........
    .........868........................*.............................17*..........348................441*852........*.....-...........@.....922
    ....................*200............311..63................452.......323.#778.*....674....................680......696...372.....*..........
    .......266.......209......589.....=......*...365.........7.*...233.............755....*......644...272........697..*....*.....682..225......
    ..836..........................949....607..........&....*..899...*....679.527.........331..........$....788../.....43....89.................
    ........367.....328.&......%...............680...69..717.......60.......*.*............................*..........................728...264.
    ........*.........*..119.253.......................................626....129...274............97...679.......752........*.......*....*.*...
    """

  static let day03Data: String? = {
    try? Self.get(file: "puzzle03.txt")
  }()

}

extension XCTestCase.Fixtures {
  enum Day04 {
    static let sample =
      """
      Card 1: 41 48 83 86 17 | 83 86  6 31 17  9 48 53
      Card 2: 13 32 20 16 61 | 61 30 68 82 17 32 24 19
      Card 3:  1 21 53 59 44 | 69 82 63 72 16 21 14  1
      Card 4: 41 92 73 84 69 | 59 84 76 51 58  5 54 83
      Card 5: 87 83 26 28 32 | 88 30 70 12 93 22 82 36
      Card 6: 31 18 13 56 72 | 74 77 10 23 35 67 36 11
      """

    static let puzzle: String? = {
      try? XCTestCase.Fixtures.get(file: "puzzle04.txt")
    }()
  }
}

extension XCTestCase.Fixtures {
  enum Day05 {

    static let sampleSeedLine = "seeds: 79 14 55 13"
    static let sampleMapEntryLine = "50 98 2"
    static let sampleMapHeader = "seed-to-soil map"
    static let sampleMap =
      """
      seed-to-soil map:
      50 98 2
      52 50 48
      """

    static let sample =
      """
      seeds: 79 14 55 13

      seed-to-soil map:
      50 98 2
      52 50 48

      soil-to-fertilizer map:
      0 15 37
      37 52 2
      39 0 15

      fertilizer-to-water map:
      49 53 8
      0 11 42
      42 0 7
      57 7 4

      water-to-light map:
      88 18 7
      18 25 70

      light-to-temperature map:
      45 77 23
      81 45 19
      68 64 13

      temperature-to-humidity map:
      0 69 1
      1 0 69

      humidity-to-location map:
      60 56 37
      56 93 4
      """

    static let puzzle: String? = {
      try? XCTestCase.Fixtures.get(file: "puzzle05.txt")
    }()
  }

}
